/*
 * Teekran.c
 *
 * Created: 10.08.2013 16:31:28
 *  Author: Nicolas
 */ 


#ifndef F_CPU
#define F_CPU 500000L // 4 MHz Quarz ATmega48
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "led_multiplex.h"
#include "encoder_panasonic.h"
#include "ioMapping.h"


// Uhr
#define TEILER 1L        // debounce clock (256Hz = 4msec)


// Timer-Interruptroutine
SIGNAL (SIG_OUTPUT_COMPARE2A)
{
  // LEDs multiplexen
  led_mpx_multiplex();

  // Drehgeber pollen
  encoder_get();
}

void servo_init(void) {
  SERVO_PWR_PORT &= ~(1<<SERVO_PWR); // ausschalten, active low
  SERVO_PWR_DDR  |=  (1<<SERVO_PWR);
  SERVO_SIG_DDR  |=  (1<<SERVO_SIG);
  
  // PWM mode 10
  TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<WGM11) | (0<<WGM10); // clear on compare match 
  TCCR1B = (0<<CS12) | (1<<CS11) | (0<<CS10) | (1<<WGM13) | (0<<WGM12); // DB S. 132
  OCR1A = 250; // 16-bit-Register
  ICR1 = 2560; // 16-bit-Register
  //ICR1 = 320;
  //ICR1 = 4000;
}


int main(void) {

  led_mpx_init(); 
	encoder_init(); 
  servo_init();  
   
	// Initialisierung Uhr/Sekundenzhler FIXME: Wenn Quarz da ist anpassen
  TCCR2A = (1<<WGM21) | (0<<WGM20);
	TCCR2B = (0<<WGM22) | (1<<CS21) | (0 << CS20); // Prescaler/Vorteiler = 1024, clear on compare
	OCR2A = TEILER;                                // Output Compare Register
	TCNT2 = 0;                                     // Timer startet mit 0
	TIMSK2 = 1<<OCIE2A;                            // beim Vergleichswertes Compare Match
  
	sei();                                

  int16_t counter = 250;
   
	// Hilfswerte Drehgeber
	uint8_t enc_this = encoder_get();
	uint8_t enc_last = enc_this;   
   
  while(1) {

 		// Drehgeber auswerten (nur Aenderungen)
 		enc_this = encoder_get();
    counter += 1*((int8_t) (enc_this-enc_last));
		enc_last = enc_this;
      
    led_mpx_putnum(counter);
        
    // Tastgrad einstellen
    OCR1A = counter;  
    }
}
