/*
 * led_multiplex.c
 *
 * Created: 10.08.2013 18:00:51
 *  Author: Nicolas
 */ 

#include <avr/io.h>
#include "led_multiplex.h"






char led_lut0[] = {0xfa,0x18,0xec,0x7c,0x1e,0x76,0xf6,0x38,0xfe,0x7e,0xbe,0xd6,0xe2,0xdc,0xe6,0xa6}; // Zifferndarstellung
static sgl_digits[N_DIGITS]; // Ziffernpuffer

// Multiplexen der LED-Anzeige; fuer schnelle Schleife gedacht
void led_mpx_multiplex (void) {
  static uint8_t i = 0;
  i++;
  if (i==N_DIGITS) {i=0;}


  uint8_t digit = sgl_digits[i];  
  
  // alles aus (active low)
  LED_PORT = 0xFF;
  GRP_PORT |= (1<<GRP_0);
  GRP_PORT |= (1<<GRP_1);
  GRP_PORT |= (1<<GRP_2);

  // Ziffer darstellen
  switch (i) {
    case 0:
      GRP_PORT &= ~(1<<GRP_0);
      break;
    case 1:
      GRP_PORT &= ~(1<<GRP_1);
      break;
    case 2:
      GRP_PORT &= ~(1<<GRP_2);
    }
    LED_PORT = ~led_lut0[digit];
}



// Zahl auf LED darstellen; 
uint8_t led_mpx_putnum(int16_t num) {
  num = abs(num);
  
  // auf darstellbaren Bereich beschraenken
  switch(N_DIGITS) {
    case 1: num %=10;    break;
    case 2: num %=100;   break;
    case 3: num %=1000;  break;
    case 4: num %=10000; break;
  }

  // Ziffen erzeugen und zwischenpuffern
  for (uint8_t i = 0; i<N_DIGITS;i++) {
    sgl_digits[i] = num%10;
    num /= 10;
  }  
  
  return 1;
}


void led_mpx_init(void) {
    // LEDs und Multiplex beide active low
    LED_DDR = 0xFF;
    GRP_DDR  |= ((1<<GRP_0) | (1<<GRP_1) | (1<<GRP_2));
    GRP_PORT |= ((1<<GRP_0) | (1<<GRP_1) | (1<<GRP_2)); 
}

